# This macro is needed at the start for building on EL6
%{?nodejs_find_provides_and_requires}

%global enable_tests 1

%global barename defs

%global commit0 7708d6fd984cf2e67936bcd13cb0de1af8134c38
%global shortcommit0 %(c=%{commit0}; echo ${c:0:7})

Name:               nodejs-defs
Version:            1.1.1
Release:            4%{?dist}
Summary:            Static scope analysis and transpilation

License:            MIT
URL:                https://www.npmjs.org/package/defs
Source0:            https://github.com/olov/%{barename}/archive/%{commit0}.tar.gz#/%{barename}-%{shortcommit0}.tar.gz
BuildArch:          noarch
%if 0%{?fedora} >= 19
ExclusiveArch:      %{nodejs_arches} noarch
%else
ExclusiveArch:      %{ix86} x86_64 %{arm} noarch
%endif

BuildRequires:      nodejs-packaging >= 6

BuildRequires:      npm(simple-is)
BuildRequires:      npm(simple-fmt)
BuildRequires:      npm(tryor)
BuildRequires:      npm(stringmap)
BuildRequires:      npm(stringset)
BuildRequires:      npm(alter)
BuildRequires:      npm(ast-traverse)
BuildRequires:      npm(breakable)
BuildRequires:      npm(esprima-fb)
BuildRequires:      npm(yargs)

%if 0%{?enable_tests}
BuildRequires:      npm(diff)
%endif


%description
Static scope analysis and transpilation of ES6 block scoped const and let
variables, to ES3

Node already supports `const` and `let` so you can use that today (run
`node --harmony` and `"use strict"`). `defs.js` enables you to do the same
for browser code. While developing you can rely on the experimental support
in Chrome (chrome://flags, check Enable experimental JavaScript). `defs.js`
is also a pretty decent static scope analyzer/linter.

%prep
%setup -qn %{barename}-%{commit0}

# Remove bundled node_modules if there are any..
rm -rf node_modules/

%nodejs_fixdep esprima-fb
%nodejs_fixdep yargs

%build
%nodejs_symlink_deps --build

pushd build
mkdir es5

node --harmony ../defs-cmd ../defs-main.js > es5/defs-main.js
node --harmony ../defs-cmd ../defs-cmd.js > es5/defs-cmd.js
node --harmony ../defs-cmd ../error.js > es5/error.js
node --harmony ../defs-cmd ../options.js > es5/options.js
node --harmony ../defs-cmd ../run-tests.js > es5/run-tests.js
node --harmony ../defs-cmd ../scope.js > es5/scope.js
node --harmony ../defs-cmd ../stats.js > es5/stats.js

cp -p defs es5
node --harmony inline-version.js
cp -r ../jshint_globals es5/
popd


%install
mkdir -p %{buildroot}%{nodejs_sitelib}/defs/build
cp -pr package.json defs-cmd.js options.js defs-main.js run-tests.js scope.js \
    stats.js error.js jshint_globals/vars.js \
    %{buildroot}%{nodejs_sitelib}/defs
cp -pr build/es5/ %{buildroot}%{nodejs_sitelib}/defs/build

%nodejs_symlink_deps


%check
%if 0%{?enable_tests}
node --harmony run-tests
pushd build/es5
node run-tests.js build/es5
popd
%endif


%files
%doc BUILD.md CHANGES.md loop-closures.md README.md semantic-differences.md jshint_globals/README
%license LICENSE jshint_globals/LICENSE.jshint
%{nodejs_sitelib}/defs/

%changelog
* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.1.1-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.1.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 1.1.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Fri Oct 23 2015 Piotr Popieluch <piotr1212@gmail.com> - 1.1.1-1
- Update to 1.1.1

* Mon Sep 07 2015 Piotr Popieluch <piotr1212@gmail.com> - 1.1.0-2
- fixdep yargs

* Sun Sep 06 2015 Piotr Popieluch <piotr1212@gmail.com> - 1.1.0-1
- Update to 1.1.0
- Use github source
- Build from source
- Enable tests

* Thu Jul 09 2015 Parag Nemade <pnemade AT fedoraproject DOT org> - 1.0.0-3
- fix yargs broken dependency version

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Tue Jul 22 2014 Ralph Bean <rbean@redhat.com> - 1.0.0-1
- Initial packaging for Fedora.
